'****************************************************************
'* QDatePick object                                             *
'*       needs a Qpanel as parent                               *
'* properties:                                                  *
'*       Top: Top position in pixels                            *
'*       left: left position in pixels                          *
'*       Width: Width in pixels                                 *
'*       height: height in pixels                               *
'*                                                              *
'*       Year: Contains the year you've selected                *
'*       Month: Contains the month you've selected              *
'*       Day: Contains the day you've selected                  *
'*                                                              *
'*       Styles: Set additional properties (see CONST DTS_ ...) *
'*       SetDate(day, month, year): sets the cal pointer to the *
'*                                  selected date               *
'*                                                              *
'* Methods:                                                     *
'*       Getdate: retrieves the selected date                   *
'*                                                              *
'* ------------------------------------------------------------ *
'* QTimePick object                                             *
'*       like at QDatePick except                               *
'* properties:                                                  *
'*       Hour: Contains the hour you've selected                *
'*       Minute: Contains the minute you've selected            *
'*       Second: Contains the second you've selected            *
'*       SetTime(hour, minute, second): sets the selected time  *
'*                                                              *
'* Methods:                                                     *
'*       Gettime: retrieves the selected time                   *
'*                                                              *
'* ------------------------------------------------------------ *
'* Donated to the Public Domain by V. Dobiasch                  *
'* Version 1.0             November 2007                        *
'****************************************************************

CONST DTS_SHORTDATEFORMAT = 0
CONST DTS_UPDOWN = 1
CONST DTS_SHOWNONE = 2
CONST DTS_LONGDATEFORMAT = 4
CONST DTS_APPCANPARSE = 6
CONST DTS_TIMEFORMAT = 9
CONST DTS_SHORTDATECENTURYFORMAT = 12
CONST DTS_RIGHTALIGN = 32

TYPE SYSTEMTIMEINC
    wYear AS SHORT
    wMonth AS SHORT
    wDayOfWeek AS SHORT
    wDay AS SHORT
    wHour AS SHORT
    wMinute AS SHORT
    wSecond AS SHORT
    wMilliseconds AS SHORT
END TYPE
DIM SysTime AS SYSTEMTIMEINC

TYPE INITCINC
    dwSize AS INTEGER
    dwICC AS INTEGER
END TYPE

DIM icexINC AS INITCINC
icexINC.dwSize = 8
icexINC.dwICC = &H100        'ICC_DATE_CLASSES

$IFNDEF __WIN32API        'for windows 32 API calls/constants
    $IFNDEF __RQINC2        ' & rapidQ2
        DECLARE FUNCTION CreateWindowEx LIB "USER32" ALIAS "CreateWindowExA" _
            (ExStyle& , ClassName$ , WindowName$ , Style& , X& , Y& , _
            Width& , Height& , WndParent& , hMenu& , hInstance& , Param&) AS LONG

        DECLARE FUNCTION SetWindowPos LIB "user32" ALIAS "SetWindowPos"(hwnd AS LONG , hWndInsertAfter AS LONG , _
            x AS LONG , y AS LONG , cx AS LONG , cy AS LONG , wFlags AS LONG) AS LONG

        $IFNDEF __RQINC        ' & rapidQ2
            DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" _
                (hwnd AS LONG , nIndex AS LONG , dwNewLong AS LONG) AS LONG
        $ENDIF
    $ENDIF
$ENDIF
DECLARE FUNCTION InitCommonControlsEx LIB "COMCTL32" ALIAS "InitCommonControlsEx" _
    (icexINC AS INITCINC) AS WORD


TYPE QDatePick EXTENDS QOBJECT

    public:
    Width AS INTEGER PROPERTY set setwposition
    Top AS INTEGER PROPERTY set settposition
    Left AS INTEGER PROPERTY set setlposition
    Height AS INTEGER PROPERTY set sethposition

    Year AS SHORT
    Month AS SHORT
    Day AS SHORT
    Styles AS INTEGER PROPERTY set setstyles

    Parent AS LONG PROPERTY set CreateDatePick
    Handle AS LONG

    CONSTRUCTOR
        Width = 110
        Height = 25
        Top = 0
        Left = 0
        Styles = 0
    END CONSTRUCTOR

    SUB CreateDatePick(f AS QPANEL)
        InitCommonControlsEx(icexINC)
        QDatePick.Handle = CreateWindowEx(0 , "SysDateTimePick32" , 0 , &H40000000 + &H10000000 + &H10000 OR QDatePick.Styles , _        'WS_CHILD + WS_VISIBLE + WS_Tabstop
            2 , 2 , QDatePick.Width , QDatePick.Height , f.Handle , 0 , 0 , 0)
    END SUB

    SUB setstyle
        SetWindowLong(QDatePick.Handle , - 16 , &H40000000 + &H10000000 + &H10000 OR QDatePick.Styles)       'WS_CHILD + WS_VISIBLE + WS_Tabstop
    END SUB

    SUB setposition
        WITH QDatePick
            SetWindowPos(.Handle , 0 ,.Left ,.Top ,.Width ,.Height , 0)
        END WITH
    END SUB

    SUB setwposition(w AS INTEGER)
        QDatePick.Width = w
        QDatePick.setposition
    END SUB

    SUB sethposition(h AS INTEGER)
        QDatePick.Height = h
        QDatePick.setposition
    END SUB

    SUB settposition(t AS INTEGER)
        QDatePick.Top = t
        QDatePick.setposition
    END SUB

    SUB setlposition(l AS INTEGER)
        QDatePick.Left = l
        QDatePick.setposition
    END SUB

    SUB setstyles(w AS INTEGER)
        QDatePick.Styles = w
        QDatePick.setstyle
    END SUB

    SUB SetDate
        WITH SysTime
            .wYear = QDatePick.year
            .wMonth = QDatePick.month
            .wDay = QDatePick.day
        END WITH
        SendMessage(QDatePick.Handle , &H1002 , 0 , SysTime)       'MCN_SETCURSEL = MCN_FIRST + 2
    END SUB

    SUB getdate
        SendMessage(QDatePick.Handle , &H1001 , 0 , SysTime)
        QDatePick.day = SysTime.wDay
        QDatePick.month = SysTime.wMonth
        QDatePick.year = SysTime.wYear
    END SUB
END TYPE

TYPE QTimePick EXTENDS QOBJECT

    public:
    Width AS INTEGER PROPERTY set setwposition
    Top AS INTEGER PROPERTY set settposition
    Left AS INTEGER PROPERTY set setlposition
    Height AS INTEGER PROPERTY set sethposition

    Hour AS SHORT
    Minute AS SHORT
    Second AS SHORT
    Styles AS INTEGER PROPERTY set setstyles

    Parent AS LONG PROPERTY set CreateTimePick
    Handle AS LONG

    CONSTRUCTOR
        Width = 100
        Height = 25
        Top = 0
        Left = 0
        Styles = 0
    END CONSTRUCTOR

    SUB CreateTimePick(f AS QPANEL) AS INTEGER
        InitCommonControlsEx(icexINC)
        QTimePick.Handle = CreateWindowEx(0 , "SysDateTimePick32" , 0 , &H40000000 + &H10000000 + &H10000 OR 9 OR QTimePick.Styles , _        'WS_CHILD + WS_VISIBLE + WS_Tabstop
            2 , 2 , QTimePick.Width , QTimePick.Height , f.Handle , 0 , 0 , 0)
    END SUB

    SUB setstyle
        SetWindowLong(QTimePick.Handle , - 16 , &H40000000 + &H10000000 + &H10000 OR 9 OR QTimePick.Styles)       'WS_CHILD + WS_VISIBLE + WS_Tabstop
    END SUB

    SUB setposition
        WITH QTimePick
            SetWindowPos(.Handle , 0 ,.Left ,.Top ,.Width ,.Height , 0)
        END WITH
    END SUB

    SUB setwposition(w AS INTEGER)
        QTimePick.Width = w
        QTimePick.setposition
    END SUB

    SUB sethposition(h AS INTEGER)
        QTimePick.Height = h
        QTimePick.setposition
    END SUB

    SUB settposition(t AS INTEGER)
        QTimePick.Top = t
        QTimePick.setposition
    END SUB

    SUB setlposition(l AS INTEGER)
        QTimePick.Left = l
        QTimePick.setposition
    END SUB

    SUB setstyles(w AS INTEGER)
        QTimePick.Styles = w
        QTimePick.setstyle
    END SUB

    SUB SetTime
        SysTime.wHour = QTimePick.Hour
        SysTime.wMinute = QTimePick.Minute
        SysTime.wSecond = QTimePick.Second
        SendMessage(QTimePick.Handle , &H1002 , 0 , SysTime)       'MCN_SETCURSEL = MCN_FIRST + 2
    END SUB

    SUB GetTime
        SendMessage(QTimePick.Handle , &H1001 , 0 , SysTime)
        QTimePick.Hour = SysTime.wHour
        QTimePick.Minute = SysTime.wMinute
        QTimePick.Second = SysTime.wSecond
    END SUB
END TYPE

